(include "linux/videodev2.h")

(in-package :cl-v4l2)

;;
;;       I O C T L   C O D E S   F O R   V I D E O   D E V I C E S
;;
(constant (vidioc-querycap "VIDIOC_QUERYCAP"))
(constant (vidioc-reserved "VIDIOC_RESERVED"))
(constant (vidioc-enum-fmt "VIDIOC_ENUM_FMT"))
(constant (vidioc-g-fmt "VIDIOC_G_FMT"))
(constant (vidioc-s-fmt "VIDIOC_S_FMT"))
(constant (vidioc-reqbufs "VIDIOC_REQBUFS"))
(constant (vidioc-querybuf "VIDIOC_QUERYBUF"))
(constant (vidioc-g-fbuf "VIDIOC_G_FBUF"))
(constant (vidioc-s-fbuf "VIDIOC_S_FBUF"))
(constant (vidioc-overlay "VIDIOC_OVERLAY"))
(constant (vidioc-qbuf "VIDIOC_QBUF"))
(constant (vidioc-dqbuf "VIDIOC_DQBUF"))
(constant (vidioc-streamon "VIDIOC_STREAMON"))
(constant (vidioc-streamoff "VIDIOC_STREAMOFF"))
(constant (vidioc-g-parm "VIDIOC_G_PARM"))
(constant (vidioc-s-parm "VIDIOC_S_PARM"))
(constant (vidioc-g-std "VIDIOC_G_STD"))
(constant (vidioc-s-std "VIDIOC_S_STD"))
(constant (vidioc-enumstd "VIDIOC_ENUMSTD"))
(constant (vidioc-enuminput "VIDIOC_ENUMINPUT"))
(constant (vidioc-g-ctrl "VIDIOC_G_CTRL"))
(constant (vidioc-s-ctrl "VIDIOC_S_CTRL"))
(constant (vidioc-g-tuner "VIDIOC_G_TUNER"))
(constant (vidioc-s-tuner "VIDIOC_S_TUNER"))
(constant (vidioc-g-audio "VIDIOC_G_AUDIO"))
(constant (vidioc-s-audio "VIDIOC_S_AUDIO"))
(constant (vidioc-queryctrl "VIDIOC_QUERYCTRL"))
(constant (vidioc-querymenu "VIDIOC_QUERYMENU"))
(constant (vidioc-g-input "VIDIOC_G_INPUT"))
(constant (vidioc-s-input "VIDIOC_S_INPUT"))
(constant (vidioc-g-output "VIDIOC_G_OUTPUT"))
(constant (vidioc-s-output "VIDIOC_S_OUTPUT"))
(constant (vidioc-enumoutput "VIDIOC_ENUMOUTPUT"))
(constant (vidioc-g-audout "VIDIOC_G_AUDOUT"))
(constant (vidioc-s-audout "VIDIOC_S_AUDOUT"))
(constant (vidioc-g-modulator "VIDIOC_G_MODULATOR"))
(constant (vidioc-s-modulator "VIDIOC_S_MODULATOR"))
(constant (vidioc-g-frequency "VIDIOC_G_FREQUENCY"))
(constant (vidioc-s-frequency "VIDIOC_S_FREQUENCY"))
(constant (vidioc-cropcap "VIDIOC_CROPCAP"))
(constant (vidioc-g-crop "VIDIOC_G_CROP"))
(constant (vidioc-s-crop "VIDIOC_S_CROP"))
(constant (vidioc-g-jpegcomp "VIDIOC_G_JPEGCOMP"))
(constant (vidioc-s-jpegcomp "VIDIOC_S_JPEGCOMP"))
(constant (vidioc-querystd "VIDIOC_QUERYSTD"))
(constant (vidioc-try-fmt "VIDIOC_TRY_FMT"))
(constant (vidioc-enumaudio "VIDIOC_ENUMAUDIO"))
(constant (vidioc-enumaudout "VIDIOC_ENUMAUDOUT"))
(constant (vidioc-g-priority "VIDIOC_G_PRIORITY"))
(constant (vidioc-s-priority "VIDIOC_S_PRIORITY"))
(constant (vidioc-g-sliced-vbi-cap "VIDIOC_G_SLICED_VBI_CAP"))
(constant (vidioc-log-status "VIDIOC_LOG_STATUS"))
(constant (vidioc-g-ext-ctrls "VIDIOC_G_EXT_CTRLS"))
(constant (vidioc-s-ext-ctrls "VIDIOC_S_EXT_CTRLS"))
(constant (vidioc-try-ext-ctrls "VIDIOC_TRY_EXT_CTRLS"))
(constant (vidioc-enum-framesizes "VIDIOC_ENUM_FRAMESIZES"))
(constant (vidioc-enum-frameintervals "VIDIOC_ENUM_FRAMEINTERVALS"))
(constant (vidioc-g-enc-index "VIDIOC_G_ENC_INDEX"))
(constant (vidioc-encoder-cmd "VIDIOC_ENCODER_CMD"))
(constant (vidioc-try-encoder-cmd "VIDIOC_TRY_ENCODER_CMD"))

;; capabilities

(constant (cap-video-capture "V4L2_CAP_VIDEO_CAPTURE")
	  :documentation "Is a video capture device")

(constant (cap-video-output "V4L2_CAP_VIDEO_OUTPUT")
	  :documentation "Is a video output device")

(constant (cap-video-overlay "V4L2_CAP_VIDEO_OVERLAY")
	  :documentation "Can do video overlay")

(constant (cap-vbi-capture "V4L2_CAP_VBI_CAPTURE")
	  :documentation "Is a raw VBI capture device")

(constant (cap-vbi-output "V4L2_CAP_VBI_OUTPUT")
	  :documentation "Is a raw VBI output device")

(constant (cap-sliced-vbi-capture "V4L2_CAP_SLICED_VBI_CAPTURE")
	  :documentation "Is a sliced VBI capture device")

(constant (cap-sliced-vbi-output "V4L2_CAP_SLICED_VBI_OUTPUT")
	  :documentation "Is a sliced VBI output device")

(constant (cap-rds-capture "V4L2_CAP_RDS_CAPTURE")
	  :documentation "RDS data capture")

(constant (cap-video-output-overlay "V4L2_CAP_VIDEO_OUTPUT_OVERLAY")
	  :documentation "Can do video output overlay")

(constant (cap-hw-freq-seek "V4L2_CAP_HW_FREQ_SEEK")
	  :documentation "Can do hardware frequency seek")

(constant (cap-tuner "V4L2_CAP_TUNER")
	  :documentation "has a tuner")

(constant (cap-audio "V4L2_CAP_AUDIO")
	  :documentation "has audio support")

(constant (cap-radio "V4L2_CAP_RADIO")
	  :documentation "is a radio device")

(constant (cap-readwrite "V4L2_CAP_READWRITE")
	  :documentation "read/write systemcalls")

(constant (cap-asyncio "V4L2_CAP_ASYNCIO")
	  :documentation "async I/O")

(constant (cap-streaming "V4L2_CAP_STREAMING")
	  :documentation "streaming I/O ioctls")

;; Pixel formats

(constant (pix-fmt-rgb332 "V4L2_PIX_FMT_RGB332")
	  :documentation "RGB1  8  RGB-3-3-2")
(constant (pix-fmt-rgb444 "V4L2_PIX_FMT_RGB444")
	  :documentation "R444 16  xxxxrrrr ggggbbbb")
(constant (pix-fmt-rgb555 "V4L2_PIX_FMT_RGB555")
	  :documentation "RGBO 16  RGB-5-5-5")
(constant (pix-fmt-rgb565 "V4L2_PIX_FMT_RGB565")
	  :documentation "RGBP 16  RGB-5-6-5")
(constant (pix-fmt-rgb555x "V4L2_PIX_FMT_RGB555X")
	  :documentation "RGBQ 16  RGB-5-5-5 BE")
(constant (pix-fmt-rgb565x "V4L2_PIX_FMT_RGB565X")
	  :documentation "RGBR 16  RGB-5-6-5 BE")
(constant (pix-fmt-bgr24 "V4L2_PIX_FMT_BGR24")
	  :documentation "BGR3 24  BGR-8-8-8")
(constant (pix-fmt-rgb24 "V4L2_PIX_FMT_RGB24")
	  :documentation "RGB3 24  RGB-8-8-8")
(constant (pix-fmt-bgr32 "V4L2_PIX_FMT_BGR32")
	  :documentation "BGR4 32  BGR-8-8-8-8")
(constant (pix-fmt-rgb32 "V4L2_PIX_FMT_RGB32")
	  :documentation "RGB4 32  RGB-8-8-8-8")
(constant (pix-fmt-grey "V4L2_PIX_FMT_GREY")
	  :documentation "GREY 8  Greyscale")
(constant (pix-fmt-y16 "V4L2_PIX_FMT_Y16")
	  :documentation "Y16  16  Greyscale")
(constant (pix-fmt-pal8 "V4L2_PIX_FMT_PAL8")
	  :documentation "PAL8 8  8-bit palette")
(constant (pix-fmt-yvu410 "V4L2_PIX_FMT_YVU410")
	  :documentation "YVU9 9  YVU 4:1:0")
(constant (pix-fmt-yvu420 "V4L2_PIX_FMT_YVU420")
	  :documentation "YV12 12  YVU 4:2:0")
(constant (pix-fmt-yuyv "V4L2_PIX_FMT_YUYV")
	  :documentation "YUYV 16  YUV 4:2:2")
(constant (pix-fmt-uyvy "V4L2_PIX_FMT_UYVY")
	  :documentation "UYVY 16  YUV 4:2:2")
(constant (pix-fmt-vyuy "V4L2_PIX_FMT_VYUY")
	  :documentation "VYUY 16  YUV 4:2:2")
(constant (pix-fmt-yuv422p "V4L2_PIX_FMT_YUV422P")
	  :documentation "422P 16  YVU422 planar")
(constant (pix-fmt-yuv411p "V4L2_PIX_FMT_YUV411P")
	  :documentation "411P 16  YVU411 planar")
(constant (pix-fmt-y41p "V4L2_PIX_FMT_Y41P")
	  :documentation "Y41P 12  YUV 4:1:1")
(constant (pix-fmt-yuv444 "V4L2_PIX_FMT_YUV444")
	  :documentation "Y444 16  xxxxyyyy uuuuvvvv")
(constant (pix-fmt-yuv555 "V4L2_PIX_FMT_YUV555")
	  :documentation "YUVO 16  YUV-5-5-5")
(constant (pix-fmt-yuv565 "V4L2_PIX_FMT_YUV565")
	  :documentation "YUVP 16  YUV-5-6-5")
(constant (pix-fmt-yuv32 "V4L2_PIX_FMT_YUV32")
	  :documentation "YUV4 32  YUV-8-8-8-8")

;; two planes -- one Y, one Cr + Cb interleaved
(constant (pix-fmt-nv12 "V4L2_PIX_FMT_NV12")
	  :documentation "NV12 12  Y/CbCr 4:2:0")
(constant (pix-fmt-nv21 "V4L2_PIX_FMT_NV21")
	  :documentation "NV21 12  Y/CrCb 4:2:0")
(constant (pix-fmt-nv16 "V4L2_PIX_FMT_NV16")
	  :documentation "NV16 16  Y/CbCr 4:2:2")
(constant (pix-fmt-nv61 "V4L2_PIX_FMT_NV61")
	  :documentation "NV61 16  Y/CrCb 4:2:2")

;;  The following formats are not defined in the V4L2 specification
(constant (pix-fmt-yuv410 "V4L2_PIX_FMT_YUV410")
	  :documentation "YUV9 9  YUV 4:1:0")
(constant (pix-fmt-yuv420 "V4L2_PIX_FMT_YUV420")
	  :documentation "YU12 12  YUV 4:2:0")
(constant (pix-fmt-yyuv "V4L2_PIX_FMT_YYUV")
	  :documentation "YYUV 16  YUV 4:2:2")
(constant (pix-fmt-hi240 "V4L2_PIX_FMT_HI240")
	  :documentation "HI24 8  8-bit color")
(constant (pix-fmt-hm12 "V4L2_PIX_FMT_HM12")
	  :documentation "HM12 8  YUV 4:2:0 16x16 macroblocks")

;; see http://www.siliconimaging.com/RGB%20Bayer.htm
(constant (pix-fmt-sbggr8 "V4L2_PIX_FMT_SBGGR8")
	  :documentation "BA81 8  BGBG.. GRGR")
(constant (pix-fmt-sgbrg8 "V4L2_PIX_FMT_SGBRG8")
	  :documentation "GBRG 8  GBGB.. RGRG")
;;
;;   10bit raw bayer, expanded to 16 bits
;;   xxxxrrrrrrrrrrxxxxgggggggggg xxxxggggggggggxxxxbbbbbbbbbb...
;;
(constant (pix-fmt-sgrbg10 "V4L2_PIX_FMT_SGRBG10")
	  :documentation "BA10")

;; 10bit raw bayer DPCM compressed to 8 bits */
(constant (pix-fmt-sgrbg10dpcm8 "V4L2_PIX_FMT_SGRBG10DPCM8")
	  :documentation "BD10")
(constant (pix-fmt-sbggr16 "V4L2_PIX_FMT_SBGGR16")
	  :documentation "BYR2 16  BGBG.. GRGR..")

;; compressed formats
(constant (pix-fmt-mjpeg "V4L2_PIX_FMT_MJPEG")
	  :documentation "MJPG Motion-JPEG")
(constant (pix-fmt-jpeg "V4L2_PIX_FMT_JPEG")
	  :documentation "JPEG JFIF JPEG")
(constant (pix-fmt-dv "V4L2_PIX_FMT_DV")
	  :documentation "dvsd 1394")
(constant (pix-fmt-mpeg "V4L2_PIX_FMT_MPEG")
	  :documentation "MPEG MPEG-1/2/4")

;;  Vendor-specific formats

(constant (pix-fmt-wnva "V4L2_PIX_FMT_WNVA")
	  :documentation "WNVA Winnov hw compress")
(constant (pix-fmt-sn9c10x "V4L2_PIX_FMT_SN9C10X")
	  :documentation "S910 SN9C10x compression")
(constant (pix-fmt-pwc1 "V4L2_PIX_FMT_PWC1")
	  :documentation "PWC1 pwc older webcam")
(constant (pix-fmt-pwc2 "V4L2_PIX_FMT_PWC2")
	  :documentation "PWC2 pwc newer webcam")
(constant (pix-fmt-et61x251 "V4L2_PIX_FMT_ET61X251")
	  :documentation "E625 ET61X251 compression")
(constant (pix-fmt-spca501 "V4L2_PIX_FMT_SPCA501")
	  :documentation "S501 YUYV per line")
(constant (pix-fmt-spca505 "V4L2_PIX_FMT_SPCA505")
	  :documentation "S505 YYUV per line")
(constant (pix-fmt-spca508 "V4L2_PIX_FMT_SPCA508")
	  :documentation "S508 YUVY per line")
(constant (pix-fmt-spca561 "V4L2_PIX_FMT_SPCA561")
	  :documentation "S561 compressed GBRG bayer")
(constant (pix-fmt-pac207 "V4L2_PIX_FMT_PAC207")
	  :documentation "P207 compressed BGGR bayer")
(constant (pix-fmt-mr97310a "V4L2_PIX_FMT_MR97310A")
	  :documentation "M310 compressed BGGR bayer")
(constant (pix-fmt-sq905c "V4L2_PIX_FMT_SQ905C")
	  :documentation "905C compressed RGGB bayer")
(constant (pix-fmt-pjpg "V4L2_PIX_FMT_PJPG")
	  :documentation "PJPG Pixart 73xx JPEG")
(constant (pix-fmt-yvyu "V4L2_PIX_FMT_YVYU")
	  :documentation "YVYU 16  YVU 4:2:2")

;;  Flags for v4l2-buffer 'flags' field
(constant (buf-flag-mapped "V4L2_BUF_FLAG_MAPPED")
	  :documentation "Buffer is mapped (flag)")

(constant (buf-flag-queued "V4L2_BUF_FLAG_QUEUED")
	  :documentation "Buffer is queued for processing")

(constant (buf-flag-done "V4L2_BUF_FLAG_DONE")
	  :documentation "Buffer is ready")

(constant (buf-flag-keyframe "V4L2_BUF_FLAG_KEYFRAME")
	  :documentation "Image is a keyframe (I-frame)")

(constant (buf-flag-pframe "V4L2_BUF_FLAG_PFRAME")
	  :documentation "Image is a P-frame")

(constant (buf-flag-bframe "V4L2_BUF_FLAG_BFRAME")
	  :documentation "Image is a B-frame")

(constant (buf-flag-timecode "V4L2_BUF_FLAG_TIMECODE")
	  :documentation "timecode field is valid")

(constant (buf-flag-input "V4L2_BUF_FLAG_INPUT")
	  :documentation "input field is valid")

;; Control IDs
(constant (cid-brightness "V4L2_CID_BRIGHTNESS"))
(constant (cid-contrast "V4L2_CID_CONTRAST"))
(constant (cid-saturation "V4L2_CID_SATURATION"))
(constant (cid-hue "V4L2_CID_HUE"))
(constant (cid-audio-volume "V4L2_CID_AUDIO_VOLUME"))
(constant (cid-audio-balance "V4L2_CID_AUDIO_BALANCE"))
(constant (cid-audio-bass "V4L2_CID_AUDIO_BASS"))
(constant (cid-audio-treble "V4L2_CID_AUDIO_TREBLE"))
(constant (cid-audio-mute "V4L2_CID_AUDIO_MUTE"))
(constant (cid-audio-loudness "V4L2_CID_AUDIO_LOUDNESS"))
(constant (cid-black-level "V4L2_CID_BLACK_LEVEL"))
(constant (cid-auto-white-balance "V4L2_CID_AUTO_WHITE_BALANCE"))
(constant (cid-do-white-balance "V4L2_CID_DO_WHITE_BALANCE"))
(constant (cid-red-balance "V4L2_CID_RED_BALANCE"))
(constant (cid-blue-balance "V4L2_CID_BLUE_BALANCE"))
(constant (cid-gamma "V4L2_CID_GAMMA"))
(constant (cid-whiteness "V4L2_CID_WHITENESS"))
(constant (cid-exposure "V4L2_CID_EXPOSURE"))
(constant (cid-autogain "V4L2_CID_AUTOGAIN"))
(constant (cid-gain "V4L2_CID_GAIN"))
(constant (cid-hflip "V4L2_CID_HFLIP"))
(constant (cid-vflip "V4L2_CID_VFLIP"))

;; Deprecated; use V4L2_CID_PAN_RESET and V4L2_CID_TILT_RESET
(constant (cid-hcenter "V4L2_CID_HCENTER"))
(constant (cid-vcenter "V4L2_CID_VCENTER"))

(constant (cid-power-line-frequency "V4L2_CID_POWER_LINE_FREQUENCY"))
(constant (cid-hue-auto "V4L2_CID_HUE_AUTO"))
(constant (cid-white-balance-temperature "V4L2_CID_WHITE_BALANCE_TEMPERATURE"))
(constant (cid-sharpness "V4L2_CID_SHARPNESS"))
(constant (cid-backlight-compensation "V4L2_CID_BACKLIGHT_COMPENSATION"))
(constant (cid-chroma-agc "V4L2_CID_CHROMA_AGC"))
(constant (cid-color-killer "V4L2_CID_COLOR_KILLER"))
(constant (cid-colorfx "V4L2_CID_COLORFX"))
(constant (cid-exposure-auto "V4L2_CID_EXPOSURE_AUTO"))
(constant (cid-exposure-absolute "V4L2_CID_EXPOSURE_ABSOLUTE"))
(constant (cid-exposure-auto-priority "V4L2_CID_EXPOSURE_AUTO_PRIORITY"))

(constant (cid-pan-relative "V4L2_CID_PAN_RELATIVE"))
(constant (cid-tilt-relative "V4L2_CID_TILT_RELATIVE"))
(constant (cid-pan-reset "V4L2_CID_PAN_RESET"))
(constant (cid-tilt-reset "V4L2_CID_TILT_RESET"))

(constant (cid-pan-absolute "V4L2_CID_PAN_ABSOLUTE"))
(constant (cid-tilt-absolute "V4L2_CID_TILT_ABSOLUTE"))

(constant (cid-focus-absolute "V4L2_CID_FOCUS_ABSOLUTE"))
(constant (cid-focus-relative "V4L2_CID_FOCUS_RELATIVE"))
(constant (cid-focus-auto "V4L2_CID_FOCUS_AUTO"))

(constant (cid-zoom-absolute "V4L2_CID_ZOOM_ABSOLUTE"))
(constant (cid-zoom-relative "V4L2_CID_ZOOM_RELATIVE"))
(constant (cid-zoom-continuous "V4L2_CID_ZOOM_CONTINUOUS"))

(constant (cid-privacy "V4L2_CID_PRIVACY"))
